diff --git a/target/linux/ar71xx/base-files/etc/board.d/01_leds b/target/linux/ar71xx/base-files/etc/board.d/01_leds
index 576d45b..cfb42a5 100755
--- a/target/linux/ar71xx/base-files/etc/board.d/01_leds
+++ b/target/linux/ar71xx/base-files/etc/board.d/01_leds
@@ -45,6 +45,11 @@ antminer-s3)
 	ucidef_set_led_default "lan" "LAN" "antminer-s3:yellow:lan" "0"
 	;;
 
+antrouter-r1)
+	ucidef_set_led_wlan "wlan" "WLAN" "antrouter-r1:green:wlan" "phy0tpt"
+	ucidef_set_led_default "btc" "BTC" "antrouter-r1:green:btc" "0"
+	;;
+
 arduino-yun)
 	ucidef_set_led_wlan "wlan" "WLAN" "arduino:blue:wlan" "phy0tpt"
 	ucidef_set_led_usbdev "usb" "USB" "arduino:white:usb" "1-1.1"
diff --git a/target/linux/ar71xx/base-files/etc/board.d/02_network b/target/linux/ar71xx/base-files/etc/board.d/02_network
index 8c57f2b..6b6c6a4 100755
--- a/target/linux/ar71xx/base-files/etc/board.d/02_network
+++ b/target/linux/ar71xx/base-files/etc/board.d/02_network
@@ -317,6 +317,7 @@ dlan-pro-1200-ac)
 all0305 |\
 antminer-s1 |\
 antminer-s3 |\
+antrouter-r1 |\
 aw-nr580 |\
 bullet-m |\
 c-55 |\
diff --git a/target/linux/ar71xx/base-files/etc/diag.sh b/target/linux/ar71xx/base-files/etc/diag.sh
index 7e2dac8..13a0a98 100644
--- a/target/linux/ar71xx/base-files/etc/diag.sh
+++ b/target/linux/ar71xx/base-files/etc/diag.sh
@@ -18,6 +18,9 @@ get_status_led() {
 	antminer-s3)
 		status_led="antminer-s3:green:system"
 		;;
+	antminer-r1)
+		status_led="antminer-r1:green:system"
+		;;
 	ap132)
 		status_led="ap132:green:status"
 		;;
diff --git a/target/linux/ar71xx/base-files/lib/ar71xx.sh b/target/linux/ar71xx/base-files/lib/ar71xx.sh
index 46e6311..61dcbba 100755
--- a/target/linux/ar71xx/base-files/lib/ar71xx.sh
+++ b/target/linux/ar71xx/base-files/lib/ar71xx.sh
@@ -114,6 +114,9 @@ tplink_board_detect() {
 	"044403"*)
 		model="ANTMINER-S3"
 		;;
+	"44440101"*)
+		model="ANTROUTER-R1"
+		;;
 	"120000"*)
 		model="MERCURY MAC1200R"
 		;;
diff --git a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
index e8998f4..cff7dfe 100755
--- a/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
+++ b/target/linux/ar71xx/base-files/lib/upgrade/platform.sh
@@ -323,6 +323,7 @@ platform_check_image() {
 
 	antminer-s1 | \
 	antminer-s3 | \
+	antrouter-r1 | \
 	archer-c5 | \
 	archer-c7 | \
 	el-m150 | \
diff --git a/target/linux/ar71xx/config-4.1 b/target/linux/ar71xx/config-4.1
index 7845aa2..fe1dd68 100644
--- a/target/linux/ar71xx/config-4.1
+++ b/target/linux/ar71xx/config-4.1
@@ -35,6 +35,7 @@ CONFIG_ATH79_MACH_ALL0258N=y
 CONFIG_ATH79_MACH_ALL0315N=y
 CONFIG_ATH79_MACH_ANTMINER_S1=y
 CONFIG_ATH79_MACH_ANTMINER_S3=y
+CONFIG_ATH79_MACH_ANTROUTER_R1=y
 CONFIG_ATH79_MACH_AP113=y
 CONFIG_ATH79_MACH_AP121=y
 CONFIG_ATH79_MACH_AP132=y
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt b/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt
index 84d22fe..cdd4fa2 100644
--- a/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt
+++ b/target/linux/ar71xx/files/arch/mips/ath79/Kconfig.openwrt
@@ -72,6 +72,16 @@ config ATH79_MACH_ANTMINER_S3
 	select ATH79_DEV_USB
 	select ATH79_DEV_WMAC
 
+config ATH79_MACH_ANTROUTER_R1
+	bool "Bitmain Antrouter R1 support"
+	select SOC_AR933X
+	select ATH79_DEV_ETH
+	select ATH79_DEV_GPIO_BUTTONS
+	select ATH79_DEV_LEDS_GPIO
+	select ATH79_DEV_M25P80
+	select ATH79_DEV_USB
+	select ATH79_DEV_WMAC
+
 config ATH79_MACH_ARDUINO_YUN
 	bool "Arduino Yun"
 	select SOC_AR933X
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/Makefile b/target/linux/ar71xx/files/arch/mips/ath79/Makefile
index 2d45225..991f6f2 100644
--- a/target/linux/ar71xx/files/arch/mips/ath79/Makefile
+++ b/target/linux/ar71xx/files/arch/mips/ath79/Makefile
@@ -44,6 +44,7 @@ obj-$(CONFIG_ATH79_MACH_ALL0258N)	+= mach-all0258n.o
 obj-$(CONFIG_ATH79_MACH_ALL0315N)	+= mach-all0315n.o
 obj-$(CONFIG_ATH79_MACH_ANTMINER_S1)+= mach-antminer-s1.o
 obj-$(CONFIG_ATH79_MACH_ANTMINER_S3)+= mach-antminer-s3.o
+obj-$(CONFIG_ATH79_MACH_ANTROUTER_R1)  += mach-antrouter-r1.o
 obj-$(CONFIG_ATH79_MACH_ARDUINO_YUN)	+= mach-arduino-yun.o
 obj-$(CONFIG_ATH79_MACH_AP113)		+= mach-ap113.o
 obj-$(CONFIG_ATH79_MACH_AP121)		+= mach-ap121.o
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/mach-antrouter-r1.c b/target/linux/ar71xx/files/arch/mips/ath79/mach-antrouter-r1.c
new file mode 100644
index 0000000..a8f7b5d
--- /dev/null
+++ b/target/linux/ar71xx/files/arch/mips/ath79/mach-antrouter-r1.c
@@ -0,0 +1,98 @@
+/*
+ *  Bitmain Antrouter R1 board support
+ *
+ *  Copyright (C) 2015 L. D. Pinney <ldpinney@gmail.com>
+ *
+ *  This program is free software; you can redistribute it and/or modify it
+ *  under the terms of the GNU General Public License version 2 as published
+ *  by the Free Software Foundation.
+ */
+
+#include <linux/gpio.h>
+
+#include <asm/mach-ath79/ath79.h>
+#include <asm/mach-ath79/ar71xx_regs.h>
+
+#include "common.h"
+#include "dev-eth.h"
+#include "dev-gpio-buttons.h"
+#include "dev-leds-gpio.h"
+#include "dev-m25p80.h"
+#include "dev-wmac.h"
+#include "machtypes.h"
+#include "dev-usb.h"
+
+#define ANTROUTER_R1_GPIO_BTN_RESET		11
+
+#define ANTROUTER_R1_GPIO_LED_WLAN		0
+#define ANTROUTER_R1_GPIO_LED_BTC		22
+#define ANTROUTER_R1_GPIO_USB_POWER		18
+
+#define ANTROUTER_R1_KEYSPOLL_INTERVAL	44	/* msecs */
+#define ANTROUTER_R1_KEYSDEBOUNCE_INTERVAL (4 * ANTROUTER_R1_KEYSPOLL_INTERVAL)
+
+static const char *ANTROUTER_R1_part_probes[] = {
+	"tp-link",
+	NULL,
+};
+
+static struct flash_platform_data ANTROUTER_R1_flash_data = {
+	.part_probes	= ANTROUTER_R1_part_probes,
+};
+
+static struct gpio_led ANTROUTER_R1_leds_gpio[] __initdata = {
+	{
+		.name		= "antrouter-r1:green:wlan",
+		.gpio		= ANTROUTER_R1_GPIO_LED_WLAN,
+		.active_low	= 0,
+	},{
+		.name		= "antrouter-r1:green:system",
+		.gpio		= ANTROUTER_R1_GPIO_LED_BTC,
+		.active_low	= 0,
+	},
+};
+
+static struct gpio_keys_button ANTROUTER_R1_GPIO_keys[] __initdata = {
+	{
+		.desc		= "reset",
+		.type		= EV_KEY,
+		.code		= KEY_RESTART,
+		.debounce_interval = ANTROUTER_R1_KEYSDEBOUNCE_INTERVAL,
+		.gpio		= ANTROUTER_R1_GPIO_BTN_RESET,
+		.active_low	= 0,
+	},
+};
+
+static void __init antrouter_r1_setup(void)
+{
+	u8 *mac = (u8 *) KSEG1ADDR(0x1f01fc00);
+	u8 *ee = (u8 *) KSEG1ADDR(0x1fff1000);
+
+	/* disable PHY_SWAP and PHY_ADDR_SWAP bits */
+	ath79_setup_ar933x_phy4_switch(false, false);
+
+	ath79_register_leds_gpio(-1, ARRAY_SIZE(ANTROUTER_R1_leds_gpio),
+				 ANTROUTER_R1_leds_gpio);
+
+	ath79_register_gpio_keys_polled(-1, ANTROUTER_R1_KEYSPOLL_INTERVAL,
+					ARRAY_SIZE(ANTROUTER_R1_GPIO_keys),
+					ANTROUTER_R1_GPIO_keys);
+
+	gpio_request_one(ANTROUTER_R1_GPIO_USB_POWER,
+			 GPIOF_OUT_INIT_HIGH | GPIOF_EXPORT_DIR_FIXED,
+			 "USB power");
+	ath79_register_usb();
+
+	ath79_register_m25p80(&ANTROUTER_R1_flash_data);
+	ath79_init_mac(ath79_eth0_data.mac_addr, mac, 1);
+	ath79_init_mac(ath79_eth1_data.mac_addr, mac, -1);
+
+	ath79_register_mdio(0, 0x0);
+	ath79_register_eth(0);
+	ath79_register_eth(1);
+
+	ath79_register_wmac(ee, mac);
+}
+
+MIPS_MACHINE(ATH79_MACH_ANTROUTER_R1, "ANTROUTER-R1",
+	     "Antrouter-R1", antrouter_r1_setup);
diff --git a/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h b/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h
index c32d44a..1b1c51a 100644
--- a/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h
+++ b/target/linux/ar71xx/files/arch/mips/ath79/machtypes.h
@@ -23,6 +23,7 @@ enum ath79_mach_type {
 	ATH79_MACH_ALL0315N,		/* Allnet ALL0315N */
 	ATH79_MACH_ANTMINER_S1,	/* Antminer S1 */
 	ATH79_MACH_ANTMINER_S3,	/* Antminer S3 */
+	ATH79_MACH_ANTROUTER_R1,	/* Antrouter-R1 */
 	ATH79_MACH_ARDUINO_YUN,		/* Yun */
 	ATH79_MACH_AP113,		/* Atheros AP113 reference board */
 	ATH79_MACH_AP121,		/* Atheros AP121 reference board */
diff --git a/target/linux/ar71xx/generic/profiles/antminer.mk b/target/linux/ar71xx/generic/profiles/antminer.mk
index d59a089..72019e3 100644
--- a/target/linux/ar71xx/generic/profiles/antminer.mk
+++ b/target/linux/ar71xx/generic/profiles/antminer.mk
@@ -26,3 +26,14 @@ define Profile/ANTMINERS3/Description
 	Package set optimized for the Bitmain Antminer S3.
 endef
 $(eval $(call Profile,ANTMINERS3))
+
+define Profile/ANTROUTER_R1
+	NAME:=Antrouter R1
+	PACKAGES:=kmod-usb-core kmod-usb2
+endef
+
+
+define Profile/ANTROUTER_R1/Description
+	Package set optimized for the Bitmain Antrouter R1.
+endef
+$(eval $(call Profile,ANTROUTER_R1))
diff --git a/target/linux/ar71xx/image/Makefile b/target/linux/ar71xx/image/Makefile
index d214eae..182fb4d 100644
--- a/target/linux/ar71xx/image/Makefile
+++ b/target/linux/ar71xx/image/Makefile
@@ -461,6 +461,14 @@ define Device/antminer-s3
     CONSOLE := ttyATH0,115200
 endef
 
+define Device/antrouter-r1
+    $(Device/tplink-8mlzma)
+    BOARDNAME := ANTROUTER-R1
+    DEVICE_PROFILE := ANTROUTER_R1
+    TPLINK_HWID := 0x44440101
+    CONSOLE := ttyATH0,115200
+endef
+
 define Device/el-m150
     $(Device/tplink-8mlzma)
     BOARDNAME := EL-M150
@@ -476,7 +484,7 @@ define Device/el-mini
     TPLINK_HWID := 0x01530001
     CONSOLE := ttyATH0,115200
 endef
-TARGET_DEVICES += antminer-s1 antminer-s3 el-m150 el-mini
+TARGET_DEVICES += antminer-s1 antminer-s3 antrouter-r1 el-m150 el-mini
 
 define Device/gl-inet-6408A-v1
     $(Device/tplink-8mlzma)